summaryrefslogtreecommitdiff
path: root/plugins/virtualenvwrapper
diff options
context:
space:
mode:
authorJaiden Mispy <^_^@mispy.me>2012-06-09 11:04:58 +1000
committerJaiden Mispy <^_^@mispy.me>2012-06-09 11:04:58 +1000
commit61ceec528533bdc2865cf3d04a9214dda6f0f173 (patch)
tree8c1e7580957471236d7072d1156ebcb4928122ed /plugins/virtualenvwrapper
parentcaa15548c107b9c31f61a67547ffab0b0cfe4934 (diff)
downloadzsh-61ceec528533bdc2865cf3d04a9214dda6f0f173.tar.gz
zsh-61ceec528533bdc2865cf3d04a9214dda6f0f173.tar.bz2
zsh-61ceec528533bdc2865cf3d04a9214dda6f0f173.zip
Plugin which loads Python virtualenvwrapper and activates virtualenvs on cd into git repos
Diffstat (limited to 'plugins/virtualenvwrapper')
-rw-r--r--plugins/virtualenvwrapper/virtualenvwrapper.plugin.zsh47
1 files changed, 47 insertions, 0 deletions
diff --git a/plugins/virtualenvwrapper/virtualenvwrapper.plugin.zsh b/plugins/virtualenvwrapper/virtualenvwrapper.plugin.zsh
new file mode 100644
index 000000000..afdad1bea
--- /dev/null
+++ b/plugins/virtualenvwrapper/virtualenvwrapper.plugin.zsh
@@ -0,0 +1,47 @@
+WRAPPER_FOUND=0
+for wrapsource in "/usr/local/bin/virtualenvwrapper.sh" "/etc/bash_completion.d/virtualenvwrapper" ; do
+ if [[ -e $wrapsource ]] ; then
+ WRAPPER_FOUND=1
+ source $wrapsource
+
+ if [[ ! $DISABLE_VENV_CD -eq 1 ]]; then
+ # Automatically activate Git projects' virtual environments based on the
+ # directory name of the project. Virtual environment name can be overridden
+ # by placing a .venv file in the project root with a virtualenv name in it
+ function workon_cwd {
+ # Check that this is a Git repo
+ GIT_DIR=`git rev-parse --git-dir 2> /dev/null`
+ if (( $? == 0 )); then
+ # Find the repo root and check for virtualenv name override
+ GIT_DIR=`readlink -f $GIT_DIR`
+ PROJECT_ROOT=`dirname "$GIT_DIR"`
+ ENV_NAME=`basename "$PROJECT_ROOT"`
+ if [[ -f "$PROJECT_ROOT/.venv" ]]; then
+ ENV_NAME=`cat "$PROJECT_ROOT/.venv"`
+ fi
+ # Activate the environment only if it is not already active
+ if [[ "$VIRTUAL_ENV" != "$WORKON_HOME/$ENV_NAME" ]]; then
+ if [[ -e "$WORKON_HOME/$ENV_NAME/bin/activate" ]]; then
+ workon "$ENV_NAME" && export CD_VIRTUAL_ENV="$ENV_NAME"
+ fi
+ fi
+ elif [ $CD_VIRTUAL_ENV ]; then
+ # We've just left the repo, deactivate the environment
+ # Note: this only happens if the virtualenv was activated automatically
+ deactivate && unset CD_VIRTUAL_ENV
+ fi
+ }
+
+ # New cd function that does the virtualenv magic
+ function cd {
+ builtin cd "$@" && workon_cwd
+ }
+ fi
+
+ break
+ fi
+done
+
+if [ $WRAPPER_FOUND -eq 0 ] ; then
+ print "zsh virtualenvwrapper plugin: Couldn't activate virtualenvwrapper. Please run \`pip install virtualenvwrapper\`."
+fi